#ifndef VARIABLE_HPP
#define VARIABLE_HPP

class Variable
{
protected : 
  double val_;
  char name_[10];

public : 
  /********** Constructors and destructors **********/
  Variable();                                        // default constructor
  Variable(const Variable& v);                       // copy constructor
  Variable(double val, char* name);                  // init constructor
  ~Variable();                                       // destructor

  /**************** Setters & Getters ***************/
  inline double getVal() const { return val_; }      // return the value of the variable
  inline void setVal(double val) { val_ = val; }     // set the value of the variable
  inline const char* getName() const { return name_; } // return the name of the variable
  
  /**************** Utility functions ***************/
  bool isNamed(const char* n) const;                 // return true if the variable is named n
};

#endif // VARIABLE_HPP
